<?php
/**
* @version $Id: kunena.birthday.php $
* Kunena Component
* @package Kunena
*
* @Copyright (C) xillibit
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* @link http://www.kunena.com
*
**/
defined( '_JEXEC' ) or die('Restricted access');

class CKunenabirthday
{
  function getUserDatas() {
    $kunena_db = &JFactory::getDBO();
    $fbConfig =& CKunenaConfig::getInstance();
    if($fbConfig->birthhacksource == 'cb'){
      $kunena_db->setQuery("SELECT a.id,a.name, a.username, cb_birthday AS birthdate FROM #__users AS a INNER JOIN #__comprofiler AS b ON a.id = b.id");
      $datas = $kunena_db->loadObjectList();
    }elseif($fbConfig->birthhacksource == 'js'){
      $kunena_db->setQuery("SELECT a.id,a.name, a.username, b.value AS birthdate FROM #__users AS a INNER JOIN #__community_fields_values AS b ON a.id = b.user_id WHERE field_id = 3");
      $datas = $kunena_db->loadObjectList();     
    }else {
      $kunena_db->setQuery("SELECT a.id,a.name, a.username, b.birthdate FROM #__users AS a INNER JOIN #__fb_users AS b ON a.id = b.userid");
      $datas = $kunena_db->loadObjectList();
    }
    return $datas;
  }
  
  //Return the age of the user gived in parameter
  function getage($birthdate){ 
    $todaydate = strftime("%Y-%m-%d" , time());
    $todaydate1 = explode("-",$todaydate);      
    $birthdate1 = explode("-",$birthdate);
    $ageyearold = $todaydate1[0] - $birthdate1[0];      
        
    return $ageyearold;
  }
  
  function countBirthday(){
    $userdatas = CKunenabirthday::getUserDatas();
    $fbConfig =& CKunenaConfig::getInstance();        
    $todaydate = strftime("%Y-%m-%d" , time());
    $todaydate1 = explode("-",$todaydate);
    $j = "0";  
    foreach( $userdatas as $row ) {         
      if ($fbConfig->birthhacksource == 'js') {
        $ubirthdate = explode(" ",$row->birthdate); 
        $row->birthdate = $ubirthdate[0];                       
      } 
      $birthdate1 = explode("-",$row->birthdate);      
      if($birthdate1[1] == $todaydate1[1] && $birthdate1[2] == $todaydate1[2]) {
        $j++;
      }
    }
    if ($j == '0') {
      $j = _STAT_NULL_BIRTHDAY_TODAY;
    }
    return $j;
  }  
    
    //Check if the user with the birthdate gived have a birthday today 
  function birthdaycheck($userbirthdate) {  
    $todaydate = strftime("%Y-%m-%d" , time());
    $todaydate1 = explode("-",$todaydate);
    $userbirthdate1 = explode("-",$userbirthdate);
    if($userbirthdate1[1] == $todaydate1[1] && $userbirthdate1[2] == $todaydate1[2]){
      return true;
    } else {
      return false;
    }    
  }
  
  function getFinalDatas(){
    $fbConfig =& CKunenaConfig::getInstance();
    $userdatas = CKunenabirthday::getUserDatas();
    //Icon to display near the name of user
    $icon = "<img src=\"images/com_kunena/user.png\" />";
    $profilelinkfinal = '';
    foreach ( $userdatas as $row) {
      if ($fbConfig->birthhacksource == 'js') {
          $ubirthdate = explode(" ",$row->birthdate);           
          $row->birthdate = $ubirthdate[0];                       
      }
      if(CKunenabirthday::birthdaycheck($row->birthdate)) {
        $username = $fbConfig->username ? $row->username : $row->name ;         
        if(isset($profilelinkfinal)) {
          $profilelinkfinal .= $icon.CKunenaLink::GetProfileLink($fbConfig, $row->id, kunena_htmlspecialchars(stripslashes($username)))." (".CKunenabirthday::getage($row->birthdate).") ";
        } else {
          $profilelinkfinal = $icon.CKunenaLink::GetProfileLink($fbConfig, $row->id, kunena_htmlspecialchars(stripslashes($username)))." (".CKunenabirthday::getage($row->birthdate).") ";
        }
       } 
    }
    if(empty($profilelinkfinal)) {
      $profilelinkfinal = _STAT_NULL_USER_BIRTHDAY;
    }
    return $profilelinkfinal;
  }  
}
?>
